**********************************************************************
*		JAZZ - Entries browser
**********************************************************************
* Following 2 names must be the same as in rtab.s
DEFINE ECRPL	LAM ~rtb
DEFINE ECDIS	LAM ~dis
DEFINE ECNTB	LAM ~ntb
	
ASSEMBLE
	CON(1)	8
RPL
xNAME EC

::
 CK0
 CHECKME			( Check Jazz is not covered )
 NULL$				( Default Search String )
 ZERO				( Default Flags )
 FIFTYSIX TestSysFlag 1LAMBIND	( Save beep flag )
 NULLNAME DoEC			( Entry point for ED ECcat & sEC )
 ::
  '

**********************************************************************
* The actual entry catalog code
* ( RTAB DTAB FONT NTAB $ #STAT #N --> ? )
* Register assignments:
*		[A]	[A1]	[A2]
*	R0	waitkey
*	R1	->STR	STARTN
*	R2	N	LOC	LOCN
*	R3	->RTAB	->DTAB	RTab[PrevN]
*	R4	->FONT	->NTAB	PrevN
*
*	STR	= 16 nibbles for time + 1+32 nibbles for str
*	STAT	= Status flag save system binary
*	NTAB	= Entry name size table for backward scanning
*
**********************************************************************

CODE

eTIMER2ON	EQU 0		Flag used by system time utilities
eBLINK		EQU 1		Blink flag for input line
eLEXICO		EQU 2		Lexico mode flag
eLMATCH		EQU 3		Match mode flag
*sBPOFF		EQU 4		Supported beep flag
eDELAY		EQU 5		Delay flag for keyrepeat
eCURSOR		EQU 6		Cursor state flag
eREPEAT		EQU 8		Key repeat enable flag
eDISPOK		EQU 9		Display validity flag
* PUSH# uses ST10
eGREP		EQU 11		Grep mode flag

=EDGREPEC	EQU 2^(eLEXICO)+2^(eLMATCH)+2^(eGREP)
=EDSCANEC	EQU 2^(eLEXICO)

		A=0	W		Initialize registers
		R0=A
		R1=A
		R2=A
		R3=A
		R4=A
		GOSBVL	=POP#		Pop entry number N
		R2=A.F	A
		GOSBVL	=POP#		Pop saved status flags
		C=A	A
		ST=C
		
		A=DAT1	A		Pop search string save
		D1=D1+	5
		D=D+1	A
		A=A+CON	A,10
		A=A+CON	A,16
		R1=A

		A=DAT1	A		Pop ->NTAB
		D1=D1+	5
		D=D+1	A
		LC(5)	=ZERO		Verify valid NTAB
		?A#C	A
		GOYES	+
		A=0	A
		ST=0	eLEXICO		just in case ...
		GONC	++
+		A=A+CON	A,10
++		GOSBVL	=ASLW5

		A=DAT1	A		Pop font
		D1=D1+	5
		D=D+1	A
		A=A+CON	A,10
		R4=A

		LC(5)	#1E9+5		Pop ->RTAB[0]
		D1=D1+	5		Skip DTAB
		A=DAT1	A	
		A=A+C	A	
		D1=D1-	5		Come back to DTAB
		GOSBVL	=ASLW5
		
		A=DAT1	A		Pop ->DTAB
		D1=D1+	5
		D=D+1	A
		GOSBVL	=ASLW5

		A=DAT1	A		Pop ->RTAB
		D1=D1+	5
		D=D+1	A
		R3=A

* Arguments now popped

		GOSBVL	=SAVPTR
		GOSBVL	=getBPOFF	Get system beep flag
		GOSUBL	EcInitClk	Initialize clock
		GOSUBL	EcSetIoAnn	Show search mode annunciator

		D1=(5)	(=IRAM@)-4	Init REPSTACK
		C=DAT1	A
		D1=C
		D1=(4)	#100
		C=0	W
		DAT1=C	W

		?ST=0	eGREP		if entry mode is grep, try update
		GOYES	+
		GOSUB	grepon
+

		ST=0	eREPEAT		make sure restart is proper
		ST=0	eDELAY		if info has been lost
		ST=0	eDISPOK

**
** Main display/keywait/dokey loop
**

ECLOOP		GOSUBL	EcDispEC	Update display if necessary
		ST=0	eBLINK		No blink in regular keywait
		GOSUBL	EcWaitKey	Wait for key
		GOSUBL	EcAdjustKey	Adjust for shifts
ECLOOP1		ST=1	eREPEAT		Assume repeat is o for the key
		ST=0	eDISPOK		Assume display will be invalid
		GOSUB	DoECKey		Do the key
		GOTO	ECLOOP		And restart the loop

**********************************************************************
* Dispatch to keyhandling subroutine given keycode
**********************************************************************

DoECKey		A=PC
		LC(5)	(ECKeyTab)-(*)
		A=A+C	A
		D0=A

EcDispatchKey
-		A=DAT0	X		Read next key in table
		D0=D0+	7		Skip to next slot (assuming no match)
		?A=0	X
		GOYES	+		End of table - dispatch
		?A#B	X
		GOYES	-		No match - continue loop
+		D0=D0-	4		Back to the offset field of the slot
		A=0	A
		A=DAT0	4		Offset
		?ABIT=0	15		Expand signed offset to A[A]
		GOYES	+
		P=	4-1
		A=-A	WP
		A=-A	A
		P=	0
+		CD0EX			And dispatch to target
		A=A+C	A
		PC=A	
**********************************************************************

**********************************************************************

ECKEY	MACRO
	CON(3)	$1			Keycode with shifts
	CON(4)	($2)-(*)		Signed offset to target
ECKEY	ENDM

* Note: The shift equates for NS LS RS ANS ALS ARS are in ED source code

ECKeyTab
		ECKEY	(UPCODE)+(NS),ECup
		ECKEY	(DOWNCODE)+(NS),ECdn
		ECKEY	(UPCODE)+(LS),ECpgup
		ECKEY	(DOWNCODE)+(LS),ECpgdn
		ECKEY	(UPCODE)+(RS),ECfarup
		ECKEY	(DOWNCODE)+(RS),ECfardn
		ECKEY	(RIGHTCODE)+(NS),ECview

		ECKEY	(ALPHACODE),ECfind
		ECKEY	(Sfkey6)+(NS),ECfind
		ECKEY	(NEXTCODE)+(NS),ECnext
		ECKEY	(NEXTCODE)+(LS),ECprev
		ECKEY	(EEXCODE)+(NS),ECgrep
		ECKEY	(Sfkey1)+(NS),EClexico
		ECKEY	(Sfkey2)+(NS),EClMatch
		ECKEY	(ENTERCODE)+(NS),ECpshent
		ECKEY	(ENTERCODE)+(LS),ECpshadr
		ECKEY	(ENTERCODE)+(RS),ECpshname

		ECKEY	(=0CODE)+(NS),ECloc
		ECKEY	(=1CODE)+(NS),ECloc
		ECKEY	(=2CODE)+(NS),ECloc
		ECKEY	(=3CODE)+(NS),ECloc
		ECKEY	(=4CODE)+(NS),ECloc
		ECKEY	(=5CODE)+(NS),ECloc
		ECKEY	(=6CODE)+(NS),ECloc
		ECKEY	(=7CODE)+(NS),ECloc
		ECKEY	(=8CODE)+(NS),ECloc
		ECKEY	(=9CODE)+(NS),ECloc
		ECKEY	(ATTNCODE)+(NS),ECExit

*		ECKEY	(ALPHACODE),EcModA
		ECKEY	(SHIFTCODE),EcModLS
		ECKEY	(ALTCODE),EcModRS
		ECKEY	(CHSCODE)+(NS),EcTogBeep
		ECKEY	(ATTNCODE)+(RS),ECOFF

		ECKEY	0,BadECKey
**********************************************************************
* Not valid key for EC - setup error flags & beep
**********************************************************************
BadECKey	ST=1	eDISPOK		Display is still valid
		ST=0	eREPEAT		Repeat is not ok
		?ST=1	sBPOFF		Beep if it is enabled
		RTNYES
		LC(2)	#FB
		GOVLNG	=RCKBp
**********************************************************************
* Exit key
**********************************************************************
ECExit		ST=0	eLMATCH		No strict match anymore
		GOSUBL	EcSetIoAnn	So we can clear the annunciator
		GOVLNG	=GPPushFLoop
**********************************************************************
* Move up one line
**********************************************************************
ECup		ST=1	eDISPOK		Display will be ok - fast scroll

		?ST=1	eGREP		Dispatch based on grep mode
		GOYES	ECup+

		A=R2
		A=A-1	A		N--
		RTNC			Already at the top - no work
		R2=A
ecupdisdn	GOSUBL	EcDispDn	Scroll display down
		D=0	A
		GOLONG	EcDispAdrRow	And display the new line

ECup+		GOSUB	EcUpdate-	Find previous grep-mode match

		GOC	ecbadup+	no previous, bad key
		C=R2
		RSTK=C			C[A] = N
	
		A=R1			get previous last row N
		GOSUBL	ASLC5
		C=A	A
		ASLC
		?CBIT=0	15		
		GOYES	ecuplstrow	if >0 then search prev N for last row
				
		A=A+1	A		if <0 dec # of blank row (neg. number)
		?A#0	A		
		GOYES	ecupR1dn	if some blank row,store N and down disp
		GOSUB	GetTot		else last row=prev N start form end
		A=A+1	A

ecuplstrow	R2=A.F	A
		GOSUB	EcUpdate-	Get prev N for last row
		A=R1
		GOSUBL	ASLC5		and store it in R1.A3
		ASLC
		A=R2.F	A		
ecupR1dn	ASRC
		GOSUBL	ASRC5
		R1=A
		C=RSTK
		R2=C.F	A
		GOTO	ecupdisdn	Ok, scroll and disp 1st line

ecbadup+	GOTO	BadECKey
**********************************************************************
* Move to top of entry table
**********************************************************************
ECfarup		?ST=1	eGREP		Dispatch to grep mode?
		GOYES	ECfarup+

		A=R2			A[A] = N
		?A=0	A		No need to update display if already
		GOYES	ecignfup	at the top entry
		A=0	A
		R2=A			N=0
		RTN
ecignfup	ST=1	eDISPOK		Validate display
		RTN

ECfarup+	A=0	A		N=0
		R2=A
		GOTO	EcUpdate	Update to new location

**********************************************************************
* Move up one page
**********************************************************************
ECpgup		?ST=1	eGREP		Dispatch to grep mode?
		GOYES	ECpgup+

		A=R2			A[A] = N
ecpgup10	A=A-CON	A,10		Move up 10 entries
		GOC	ECfarup		Overflow - same code as for far-up

ecignup?	C=R2			C[A] = N
		R2=A			R2[A] = N'
		?A#C	A
		RTNYES			If different then return
		ST=1	eDISPOK		Else no display update needed
		RTN

ECpgup+		GOTO	BadECKey	No page-up in grep mode
**********************************************************************
* Move to bottom of entry table
**********************************************************************
ECfardn	
*		?ST=1	eGREP		Dispatch to grep mode?
*		GOYES	ECfardn+

		GOSUB	GetTot		A[A] = MAXN
		A=A+1	A		A[A] = MAXN+1

		?ST=0	eGREP		if GREP mode
		GOYES	ecpgup10	  then simply do a page-up
		R2=A.F	A		else find last match
		GOSUB	EcUpdate-	
		RTN

**********************************************************************
* Move down one page
**********************************************************************
ECpgdn		?ST=1	eGREP		Dispatch to grep mode?
		GOYES	ecbaddn+
		A=R2			A[A] = N
		A=A+CON	A,10		Down one page
		C=A	A		C[A] = N'
		GOSUB	GetTot		A[A] = MAXN
		C=C+CON	A,10
		?C>A	A		Dispatch to far-down if no more
		GOYES	ECfardn		full pages
		C=C-CON	A,10
		R2=C			N = N'
		RTN
**********************************************************************
* Move down one line
**********************************************************************
ECdn		?ST=1	eGREP		Dispatch to grep mode?
		GOYES	ECdn+

		GOSUB	GetTot		A[A] = MAXN
		C=R2
		C=C+1	A		C[A] = N+1
		?C>A	A
		GOYES	ecigndn		Ignore if alread at the bottom

ecfastdn	RSTK=C			Save N+1
		C=C+CON	A,10-1
		R2=C
ecdspulst	GOSUBL	EcDispUp	Scroll display upwards
		LC(3)	#900
		D=C	A
		GOSUBL	EcDispAdrRow	Display the new last row
ecdnend		C=RSTK			And set N = N+1
		R2=C
ecigndn		ST=1	eDISPOK		Validate displat
		RTN

ecbaddn+	GOTO	BadECKey
		
ECdn+		GOSUB	EcUpdate+	Find next grep-mode entry
		GOC	ecbaddn+	No more - error
		C=R2
		RSTK=C			C[A] = N
		A=R1			Get prev N for last row
		GOSUBL	ASLC5
		C=A	A
		ASLC
		?CBIT=0	15		if >=0 then search next N for lst row
		GOYES	+
		A=A-1	A		else inc # of blank row
		GOTO	ecdnR1clr	 and save in R1 and clear last line

+		R2=A.F	A
		GOSUB	EcUpdLast+	Get next N for last row
		GONC	ecdnR1up	 if Ok,save new N in R1 & up display
		A=R1			else, store (-)1 blank row ...	
		GOSUBL	ASLC5
		ASLC
		A=0	A
		A=A-1	A
ecdnR1clr	ASRC			in R1.A3 ...	
		GOSUBL	ASRC5
		R1=A
		GOSUBL	EcDispUp	scroll disp up ...
		LC(3)	#900
		D=C	A
		GOSUBL	dirowblank	and clear last row
		GOTO	ecdnend		Restore R2 and end
	
ecdnR1up	A=R1			Store new N for last row
		GOSUBL	ASLC5
		ASLC
		A=R2.F	A	
		ASRC
		GOSUBL	ASRC5
		R1=A			in R1.A3
		GOTO	ecdspulst	and scroll+ update last row

**********************************************************************
* Switch grep flag
**********************************************************************
ECgrep		A=R1
		D0=A			D0 = ->STR
		A=DAT0	S		A[S] = strlen
		?A#0	S
		GOYES	grepok		Continue if nonnull string
		GOTO	BadECKey

grepok		ST=0	eREPEAT		No repeat

		?ST=0	eGREP		Toggle grep flag
		GOYES	grepon
		ST=0	eGREP
		RTN
grepon		ST=1	eGREP
		GOSUB	EcUpdate
		RTNNC
		GOSUB	EcUpdate-
		RTNNC
		ST=0	eGREP
		GOTO	BadECKey
**********************************************************************
* Find next match
**********************************************************************
ECnext		A=R1
		D0=A			D0 = ->STR
		A=DAT0	S
		?A=0	S
		GOYES	ecnxtbad	Error if no search string
		GOSUB	EcUpdate+	Skip to next match
		RTNNC			Done if found one
ecnxtbad	GOTO	BadECKey	Error - no match
**********************************************************************
* Find previous match
**********************************************************************
ECprev		A=R1
		D0=A			D0 = ->STR
		A=DAT0	S
		?A=0	S
		GOYES	ecnxtbad	Error if no search string
		GOSUB	EcUpdate-	Skip to previous match
		RTNNC			Done if found one
		GOC	ecnxtbad	Error - no match
**********************************************************************
* Call DOB/ED subprogram to view disassembly of entry
**********************************************************************
ECview		GOSUB	GetEntrN	D0 = ->entry slot N
		A=DAT0	A
		R0=A
		GOSBVL	=PUSH#		Push entry address
		GOSBVL	=SAVPTR
		C=0	A		Push operation code : view
		R0=C
		GOSBVL	=PUSH#
		GOSBVL	=SAVPTR
		C=0	A		Push status flags
		C=ST
		R0=C
		GOSBVL	=PUSH#
		GOSBVL	=SAVPTR
		ST=0	eLMATCH		Update annunciators
		GOSUBL	EcSetIoAnn
		GOSBVL	=GETPTR		Push N
		C=R2
		R0=C
		GOSBVL	=PUSH#
		GOVLNG	=PushTLoop	Push TRUE - job to do
**********************************************************************
* Push current entry name & address
**********************************************************************
ECpshent	GOSUB	GetEntrN	D0 = ->entry slot N
		D0=D0+	5		Skip address part
		A=0	A
		A=DAT0	1		A[A] = chars in name
		A=A+A	A
		LC(5)	5+2+15		+ DOTAG + namelen + addressobject
		C=C+A	A
		GOSBVL	=GETTEMP
		CD0EX
		R0=C			R0[A] = ->obhect
		D1=C
		LC(5)	=DOTAG		Output DOTAG
		DAT1=C	A
		D1=D1+	5
		GOSUB	GetEntrN	D0 = ->entry slot N
		D0=D0+	5		Skip address part
		C=0	A
		C=DAT0	1		C[A] = chars in name
		D0=D0+	1
		DAT1=C	B		Output tagname length
		D1=D1+	2
		C=C+C	A		Copy tagname
		GOSBVL	=MOVEDOWN
		GOTO	ecunadrent	Common code for address part
**********************************************************************
* Push current entry address
**********************************************************************
ECpshadr	LC(5)	15		DOHSTR + length + address
		GOSBVL	=GETTEMP
		CD0EX
		R0=C			R0[A] = ->hstr
		D1=C

ecunadrent	GOSUB	GetEntrN	D0 = ->entry slot N
		LC(5)	=DOHSTR		Output DOHSTR
		DAT1=C	A
		D1=D1+	5
		LC(5)	5+5		Output HSTR size
		DAT1=C	A
		D1=D1+	5
		A=DAT0	A		Output address
		DAT1=A	A
		D1=D1+	5
		GONC	ecunent		Common code to push
**********************************************************************
* Push entry name
**********************************************************************
ECpshname	GOSUB	GetEntrN	D0 = ->entry slot N
		D0=D0+	5
		C=0	A
		C=DAT0	1		chars in name
		GOSBVL	=MAKE$		Create string for it
		CD0EX
		D1=C
		GOSUB	GetEntrN	D0 = ->entry slot N
		D0=D0+	5
		C=0	A
		C=DAT0	1		C[A] = chars in name
		D0=D0+	1
		C=C+C	A		Copy entryname to string
		GOSBVL	=MOVEDOWN

ecunent		ST=0	eREPEAT		No repeat when pushing
		ST=1	eDISPOK
		A=R0			Push the string to stack
		GOSBVL	=GPPushA
		GOVLNG	=SAVPTR		And save the new pointers
**********************************************************************
* Fetch the number of entries from DIS.TAB
* Output:	A[A] = MAXN
**********************************************************************
GetTot		A=R3
		GOSBVL	=ASRW5
		D0=A
		D0=D0+	10+4
		A=DAT0	A
		A=A-1	A
		RTN
**********************************************************************
GetEntrN	C=R2.F	A
		GOLONG	N>Entr
**********************************************************************
ECloc		ST=0	eGREP
		ST=0	eLEXICO
		C=0	W
		P=	15
		LC(1)	5
		P=	0
		C=R2.F	A
		R2=C
		GOTO	eclockey
locloop		GOSUB	GetLoc
		GOSUBL	ECentry?
		A=B	A
		R2=A.F	A
		GOSUB	EcDispEC9
		GOSUB	EcDispLoc
		ST=0	eBLINK
		GOSUBL	EcWaitKey
		GOSUBL	EcAdjustKey
eclockey
		ST=1	eREPEAT
		GOSUB	DoLocKey
		GOTO	locloop

DoLocKey
		GOSUB	LocNumKey?
		A=PC
		LC(5)	(ECLocKeyTab)-(*)
		A=A+C	A
		D0=A
		GOLONG	EcDispatchKey

ECLocKeyTab
		ECKEY	(ENTERCODE)+(NS),LocExit
		ECKEY	(ATTNCODE)+(NS),LocExit
		ECKEY	(DELCODE)+(NS),LocDEL
		ECKEY	(BACKCODE)+(NS),LocBS
		ECKEY	0,BadLocKey
		
**********************************************************************
LocDEL
**********************************************************************
LocExit		ST=0	eREPEAT
		ST=0	eDISPOK
		GOTO	ECLOOP
**********************************************************************
LocBS		A=R2
		A=A+1	S
		P=	15
		LC(1)	5
		P=	0
		?A>=C	S
		GOYES	LocExit
		P=	10-1
		ASR	WP
		P=	0
		A=R2.F	A
		R2=A
		RTN
**********************************************************************
BadLocKey
		C=B	A
		RSTK=C
		GOSUB	EcDispEC
		C=RSTK
		B=C	A
		GOTO	ECLOOP1
**********************************************************************
LocNumKey?
		LC(3)	#100
		?B#C	XS		Not NS?
		RTNYES	
		GOSUB	+
		CON(2)	=0CODE
		CON(2)	=1CODE
		CON(2)	=2CODE
		CON(2)	=3CODE
		CON(2)	=4CODE
		CON(2)	=5CODE
		CON(2)	=6CODE
		CON(2)	=7CODE
		CON(2)	=8CODE
		CON(2)	=9CODE
		CON(2)	=Sfkey1
		CON(2)	=Sfkey2
		CON(2)	=Sfkey3
		CON(2)	=Sfkey4
		CON(2)	=Sfkey5
		CON(2)	=Sfkey6
+		C=RSTK
		D0=C
		A=0	A
-		C=DAT0	B
		D0=D0+	2
		?B=C	B
		GOYES	+
		A=A+1	P
		GONC	-
		RTN			Not numkey

+		C=RSTK			Pop ret
		C=R2
		GOSBVL	=CSRW5
		CSL	A
		C=C+A	A
		GOSBVL	=CSLW5
		C=R2.F	A
		?C=0	S
		GOYES	+
		C=C-1	S
+		R2=C
		RTN
**********************************************************************
EcDispLoc	LC(1)	10-1
		GOSUB	EcSetRow
		GOSUB	EcClrRow
		D1=D1+	1
		GOSUB	+
		GOSUB	GetLoc
		GOTO	EcDispAddr
+		GOSUB	EcDisp:
		ASC(1)	'Loc:'
**********************************************************************
GetLoc		A=R2
		GOSBVL	=ASRW5
		A=R2.F	S
-		A=A-1	S
		RTNC
		ASL	A
		GONC	-
**********************************************************************
ECfind
* Set alpha mode	
		GOSUBL	EcGetAnns
		ABIT=1	6
		DAT0=A	B
		D0=(5)	=ANNCTRL
		A=DAT0	B
		ABIT=1	2
		DAT0=A	B
		
		ST=0	eGREP
		A=R2
		GOSBVL	=ASLW5
		A=R1.F	A
		R1=A
		D0=A
		A=0	A
		DAT0=A	1
		ST=0	eCURSOR
--
		GOSUB	EcDispEC9
		GOSUB	EcDispFind
		GOSUBL	EcSetCursor
		ST=1	eBLINK
		GOSUBL	EcWaitKey
		GOSUBL	EcAdjustKey
		GOSUBL	EcClrCursor
		ST=1	eREPEAT
		GOSUB	DoECFKey
		GOTO	--
**********************************************************************
DoECFKey
		A=R1
		D1=A
		GOSUBL	EcChrKey?
		GONC	DoECFNonChr
		GOTO	DoECFChrKey
DoECFNonChr
		A=PC
		LC(5)	(ECFKeyTab)-(*)
		A=A+C	A
		D0=A
		GOLONG	EcDispatchKey
**********************************************************************
ECFKeyTab
		ECKEY	(BACKCODE)+(NS),ECFbs
		ECKEY	(BACKCODE)+(ANS),ECFbs
		ECKEY	(DELCODE)+(NS),ECFdel
		ECKEY	(DELCODE)+(ANS),ECFdel
		ECKEY	(ATTNCODE)+(NS),ECFexit
		ECKEY	(ATTNCODE)+(ANS),ECFexit
		ECKEY	(ENTERCODE)+(NS),ECFexit
		ECKEY	(ENTERCODE)+(ANS),ECFexit
		ECKEY	(NEXTCODE)+(NS),ECFnext
		ECKEY	(ALPHACODE),EcModA
		ECKEY	(SHIFTCODE),EcModLS
		ECKEY	(ALTCODE),EcModRS
		ECKEY	(CHSCODE)+(NS),EcTogBeep
		ECKEY	(ATTNCODE)+(RS),ECOFF
		ECKEY	0,ECFBadKey
**********************************************************************
ECFexit		ST=0	eREPEAT
		ST=0	eDISPOK
* Clr alpha mode	
		GOSUBL	EcGetAnns
		ABIT=0	6
		DAT0=A	B
		D0=(5)	=ANNCTRL
		A=DAT0	B
		ABIT=0	2
		DAT0=A	B
		GOTO	ECLOOP
**********************************************************************
ECFdel		A=0	S
		DAT1=A	S
**********************************************************************
ECFbs		A=R1
		GOSBVL	=ASRW5	START N
		R2=A.F	A
		A=DAT1	S
		A=A-1	S
		GOC	ECFexit
		DAT1=A	S
		?A=0	S
		GOYES	ECFexit
		GOTO	EcUpdate
**********************************************************************
ECFBadKey
		?ST=1	sBPOFF
		RTNYES
		LC(2)	#FB
		GOVLNG	=RCKBp
**********************************************************************
ECFnext		GOSUB	EcUpdate+
		RTNNC
		GOTO	ECFBadKey
**********************************************************************
* C[B]=chr
**********************************************************************
DoECFChrKey
* To Upper
		A=C	B
		LCASC	'a'
		?A<C	B
		GOYES	+
		LCASC	'z'
		?A>C	B
		GOYES	+
		ABIT=0	5
+		C=DAT1	S
		C=C+1	S
		GOC	ECFBadKey
		DAT1=C	S
		P=C	15
		CD1EX
		C+P+1
		C+P+1
		CD1EX
		P=	0
		D1=D1-	3
		DAT1=A	B
		GOSUB	EcDispFind
		GOSUB	EcUpdate
		RTNNC
		GOTO	ECFBadKey
**********************************************************************
EcUpdLast+
		C=R2
		C=C+1	A	N++
		R2=C
EcUpdLast
		GOSUB	GetTot
		R0=A
		GOTO	EcUpdate!
**********************************************************************
EcUpdate+	C=R2		Save N
		R0=C
		C=C+1	A	N++
		R2=C
		GOTO	EcUpdate!
**********************************************************************
EcUpdate	C=R2		Save N
		R0=C
**********************************************************************
EcUpdate!	GOSUB	EcPrepUpdate
		GOC	++		Too big N  (was RTNC)
		?ST=0	eLEXICO		If lexico mode, use N>Entr
		GOYES	EcupdNoLex	  to get next entry.
					Slower but does work ...
		C=R2.F	A		
--		GOSUB	N>Entr		N>Entr tests if no more offsets 
		GOC 	++
		GOSUB	EcMatch?
		RTNNC	Match
		C=R2.F	A
		C=C+1	A
		R2=C.F	A
		GONC	--
		
EcupdNoLex

--		D0=C			->entry_offset
		A=DAT0	A		address
		?A=0	A
		GOYES	++		No more offsets
		RSTK=C
		C=R3.F	A		->rtab
		A=A+C	A
		D0=A			->entry
		GOSUB	EcMatch?
		C=RSTK
		RTNNC			Match
		A=R2.F	A
		A=A+1	A		N++
		R2=A.F	A
		C=C+CON	A,5		->next offset
		GONC	--
++		C=R0			restore N and fail update
		R2=C
		RTNSC
**********************************************************************
EcUpdate-	C=R2
		R0=C
		C=C-1	A
		RTNC
		R2=C
EcUpdate!!
		GOSUB	EcPrepUpdate
		RTNC			Too big N

		?ST=0	eLEXICO
		GOYES	EcupdNoLex-

		C=R2
--		GOSUB	N>EntLex	If lexico mode, use N>EntLex
		GOSUB	EcMatch?	(like N>Entr but no useless check
		RTNNC	Match		  on offset)
		C=R2.F	A
		C=C-1	A
		R2=C.F	A
		GONC	--
		GOTO	EcUpd!!End

EcupdNoLex-

--		RSTK=C
		D0=C
		A=DAT0	A
		C=R3.F	A
		A=A+C	A
		D0=A
		GOSUB	EcMatch?
		C=RSTK
		RTNNC	Match
		C=C-CON	A,5
		A=R2.F	A
		A=A-1	A
		R2=A.F	A
		GONC	--

EcUpd!!End	C=R0
		R2=C
		RTNSC
**********************************************************************
EcPrepUpdate
		C=R3
		GOSBVL	=CSRW5		->dtab
		D0=C
		D0=D0+	10+4
		A=DAT0	A		entries
		C=R2.F	A
		C=C+1	A		N+1
		?C>A	A
		RTNYES			Too Big N
		A=C	A
		A=A+A	A
		A=A+A	A
		C=C+A	A
		AD0EX
		C=C+A	A		->entry
		A=R1.F	A
		D1=A			->STR
		A=DAT1	S		strlen
		D1=D1+	1		->str
		RTNCC
**********************************************************************
EcMatch?	D0=D0+	5
		C=DAT0	S		entrylen
		?A>C	S
		RTNYES			Too short for submatch
		D0=D0+	1
--		A=DAT0	B
		D0=D0+	2
		LCASC	'a'		Convert to upper case
		?A<C	B
		GOYES	+
		LCASC	'z'
		?A>C	B
		GOYES	+
		ABIT=0	5
+		C=DAT1	B
		?A=C	B
		GOYES	eccmprest	First char matches, try rest
eccmp20		

		?ST=1	eLMATCH		Test only first chars
		RTNYES

		C=C-1	S		entrylen--
		?C>=A	S		Still enough for submatch?
		GOYES	--		Yes
		RTNSC			Nope - no match
ecretmatch	RTNCC

eccmprest	CD0EX
		B=C	A		->char1
		CD0EX
--		A=A-1	S
		?A=0	S
		GOYES	ecretmatch
		A=DAT0	B
		D0=D0+	2
		LCASC	'a'		To upper case
		?A<C	B
		GOYES	+
		LCASC	'z'
		?A>C	B
		GOYES	+
		ABIT=0	5
+		D1=D1+	2
		C=DAT1	B
		?A=C	B
		GOYES	--
		C=B	A
		D0=C			->char1
		A=R1.F	A		Restore strlen
		D1=A
		A=DAT1	S
		D1=D1+	1
		GOTO	eccmp20
**********************************************************************
EcDispFind
		LC(1)	10-1
		GOSUB	EcSetRow
		GOSUB	EcClrRow
		D1=D1+	1
		GOSUB	dspfnd
		A=R1	A
		D0=A
		A=DAT0	S
		D0=D0+	1
-		A=A-1	S
		RTNC
		C=DAT0	B
		D0=D0+	2
		GOSUB	EcDispChr
		GONC	-

dspfnd		GOSUB	EcDisp:
		ASC(1)	'Find:'

**********************************************************************
EcDispEC9	LC(1)	9-1
		GOTO	EcDispECN

EcDispEC	?ST=1	eDISPOK
		RTNYES
		LC(1)	10-1		Rows

EcDispECN	D=C	A		rows=C[0]
		D=0	XS		row=0

		C=RSTK			Save RSTK level and R2[A]
		GOSBVL	=CSLW5
		C=R2.F	A
		GOSBVL	=CSLW5
		C=D	A
		D=C	W		D[A1]=R2[A]	D[A2]=RSTK

-		GOSUB	EcDispAdrRow	Display row
		GOC	ecdispnomore	No more entries?
		C=R2	A
		C=C+1	A		entrynum++
		R2=C	A
		D=D+1	XS		row++
		D=D-1	P		rows--
		GONC	-
		GOC	ecdispexit

ecdispnomore	C=0	A		store -D[0] in R1
		C=D	P
		C=-C	A
		R2=C.F	A
-		GOSUB	dirowblank	and clear next lines
		D=D+1	XS
		D=D-1	P
		GONC	-

ecdispexit	A=R1			Store in R1 N for last
		GOSUB	ASLC5		row 
		ASLC
		A=R2.F	A		(or # of blank row)
		A=A-1	A		
		ASRC
		GOSUB	ASRC5
		R1=A

		C=D	W		Restore R2[A]
		GOSBVL	=CSRW5
		R2=C.F	A
		GOSBVL	=CSRW5		Restore RSTK
		RSTK=C
		RTN
**********************************************************************
EcDispAdrRow
		?ST=0	eGREP
		GOYES	+
		GOSUB	EcUpdLast
		GOC	dirowblank
+		C=R2	A
		GOSUB	N>Entr
		GONC	+

dirowblank	GOSUB	SetECRow
		GOSUB	EcClrRow
		RTNSC			let know to EcDispEc that we failed

+		GOSUB	SetECRow
		GOSUB	EcClrRow
		A=DAT0	A
		GOSBVL	=ASLW5		A[A1]=ADDR
		AD1EX
		B=A	W
		AD1EX
		D1=D1+	1		1 SPC
		A=DAT0	A
		D0=D0+	5
		GOSUB	EcDispAddr
		D1=D1+	2		2 SPC
		GOSUB	EcDispName
		C=B	W
		D1=C
		D1=D1+	16
		D1=D1+	13		4 CHARS LEFT
		GOSBVL	=CSRW5
		D0=C
		GOSUB	EcDispType
		RTNCC			let know to EcDispEC that we success
**********************************************************************
EcClrRow	LC(5)	34*6
		GOSBVL	=WIPEOUT
		LC(5)	34*6
		GOTO	EcDispLoc-
**********************************************************************
SetECRow
		C=D	XS
		CSR	X
		CSR	B
EcSetRow	P=C	0
		C=0	A
		C=P	0
		CPEX	1
		C=C+C	A		#22*
		C=C+C	A		#44*
		A=C	A
		C=C+C	A		#88*
		C=C+A	A		#CC*
		
		D1=(5)	=aADISP
		A=DAT1	A
		D1=A
		A=DAT1	A
		A=A+C	A
		LC(5)	20+2*34
		A=A+C	A
		D1=A
		RTN
**********************************************************************
EcDispType
		A=DAT0	A		first 5 nibbles

		LC(5)	#7E000		Protect from GX bank switch!
		?A>=C	A
		GOYES	ectypedat	

		AD0EX
		C=DAT0	A
		D0=A
		A=C	A		first 5 nibbles at address
		LC(5)	=PRLG
		?A=C	A
		GOYES	ectypeob
ectypedat	A=DAT0	A
		D0=D0+	5
		CD0EX
		?A=C	A
		GOYES	+
ectypeml	GOSUB	EcDisp:
		ASC(1)	'ML'
+		GOSUB	EcDisp:
		ASC(1)	'PCO'

ectypeob	A=DAT0	A
		GOSUB	+
		CON(5)	=DOBINT
		ASC(1)	'#'
		CON(5)	=DOREAL
		ASC(1)	'%'
		CON(5)	=DOEREL
		ASC(1)	'%%'
		CON(5)	=DOCMP
		ASC(1)	'C%'
		CON(5)	=DOECMP
		ASC(1)	'C%%'
		CON(5)	=DOCHAR
		ASC(1)	'CHR'
		CON(5)	=DOARRY
		ASC(1)	'[]'
		CON(5)	=DOLNKARRY
		ASC(1)	'[L]'
		CON(5)	=DOCSTR
		ASC(1)	'$'
		CON(5)	=DOHSTR
		ASC(1)	'HXS'
		CON(5)	=DOLIST
		ASC(1)	'{}'
		CON(5)	=DORRP
		ASC(1)	'RRP'
		CON(5)	=DOSYMB
		ASC(1)	'SYMB'
		CON(5)	=DOEXT
		ASC(1)	'EXT'
		CON(5)	=DOTAG
		ASC(1)	'TAG'
		CON(5)	=DOGROB
		ASC(1)	'GROB'
		CON(5)	=DOLIB
		ASC(1)	'LIB'
		CON(5)	=DOBAK
		ASC(1)	'BAK'
		CON(5)	=DOEXT0
		ASC(1)	'EXT0'
		CON(5)	=DOEXT1
		ASC(1)	'EXT1'
		CON(5)	=DOEXT2
		ASC(1)	'EXT2'
		CON(5)	=DOEXT3
		ASC(1)	'EXT3'
		CON(5)	=DOEXT4
		ASC(1)	'EXT4'
		CON(5)	=DOCOL
		ASC(1)	'::'
		CON(5)	=DOCODE
		ASC(1)	'CODE'
		CON(5)	=DOIDNT
		ASC(1)	'ID'
		CON(5)	=DOLAM
		ASC(1)	'LAM'
		CON(5)	=DOROMP
		ASC(1)	'ROMP'
		CON(5)	0

+		C=RSTK
		D0=C
-		C=DAT0	A
		D0=D0+	5
		?C#0	A		avoid rare non-match crash
		GOYES	+
		GOTO	ectypeml
+		?A=C	A
		GOYES	EcDispName
		C=0	A
		C=DAT0	1
		AD0EX
		A=A+C	A
		A=A+C	A
		AD0EX
		D0=D0+	1
		GONC	-
**********************************************************************
EcDisp:		C=RSTK
		D0=C
**********************************************************************
EcDispName
		A=DAT0	S
		D0=D0+	1
		A=A-1	S
		RTNC
-		C=DAT0	B
		D0=D0+	2
		GOSUB	EcDispChr
		A=A-1	S
		GONC	-
		RTN
**********************************************************************
EcDispAddr
		ASRC
		ASRC
		ASRC
		ASRC
		ASRC
		GOSUB	EcDispSNib
		GOSUB	EcDispSNib
		GOSUB	EcDispSNib
		GOSUB	EcDispSNib
*		GOTO	EcDispSNib	
**********************************************************************
EcDispSNib
		ASLC
EcDispNib	LCASC	'9'
		ACEX	P
		?C<=A	P
		GOYES	EcDispChr
		C=C+CON	A,7
**********************************************************************
EcDispChr	A=0	A
		A=C	B
		A=A+A	X
		C=A	X
		A=A+A	X
		A=A+C	X
		C=R4.F	A
		C=C+A	A
		CD0EX
		A=DAT0	6
		D0=C
-		DAT1=A	P
		D1=D1+	16
		D1=D1+	16
		D1=D1+	2
		P=P+1
		?P#	6	
		GOYES	-
		P=	0
EcDispLoc+1	LC(5)	34*6-1
EcDispLoc-	AD1EX
		A=A-C	A
		AD1EX
		RTNCC
**********************************************************************
EcInvChrs	C=C-1	S
		RTNC
		GOSUB	EcInvChr
		GONC	EcInvChrs
**********************************************************************
EcInvChr	P=	16-6
-		A=DAT1	B
		A=-A-1	B
		DAT1=A	1
		D1=D1+	16
		D1=D1+	16
		D1=D1+	2
		P=P+1
		GONC	-
		GOC	EcDispLoc+1
**********************************************************************
EcDispDn	LC(1)	11-1
		GOSUB	EcSetRow
		LC(5)	6*34
		A=A-C	A
		D0=A
		LC(5)	9*6*34
		GOVLNG	=MOVEUP
**********************************************************************
EcDispUp	LC(1)	1-1
		GOSUB	EcSetRow
		LC(5)	6*34
		A=A+C	A
		D0=A
		LC(5)	9*6*34
		GOVLNG	=MOVEDOWN
**********************************************************************
* IN:	C[A]=N-1 R3=TABS
* OUT:	CC: D0=->ENTR
*	CS: TOO BIG N
* USES:	A[9-0] D0
* USES 1 stack level in lexico mode
**********************************************************************
N>Entr		P=	10-1
		A=R3.F	WP
		ASR	WP
		ASR	WP
		ASR	WP
		ASR	WP
		ASR	WP
		P=	0
		D0=A
		D0=D0+	10+4
		A=DAT0	A
		D0=D0+	5
		?C>=A	A
		RTNYES		Too Big N

		?ST=1	eLEXICO
		GOYES	N>EntLex

		A=C	A
		A=A+A	A
		A=A+A	A
		A=A+C	A
		CD0EX
		C=C+A	A
		CD0EX
		A=DAT0	A	OFFSET
		CD0EX
*		C=R3.F	A

		CR3EX.F	A
		A=A+C	A
		CR3EX.F	A
		ACEX	A

*		C=C+A	A
		CD0EX
		RTNCC

N>EntLex			Use as few registers as possible ...
		AR4EX		->FONT	->NTAB	PrevN S
	 	GOSUB   ASRC5	->NTAB	N S ->FONT	
		CD0EX		D0=N
		C=A	A	C=NTAB
	 	GOSUB   ASRC5	->PrevN S ->FONT ->NTAB	
		C=C+A	A	C=NTab+PrevN
		CD0EX		D0=NTab+PrevN ; C=N
		ACEX	A	N S ->FONT ->NTAB	; C=PrevN
		C=A-C	A	C=N-PrevN
	 	GOSUB   ASLC5	->NTAB	N S ->FONT	
	 	GOSUB   ASLC5	->FONT ->NTAB N S
		AR4EX
		A=0	A
	        GOC 	N>EntRlp	ReverseLoop

N>Entlp		C=C-1	A		Loop from PrevN to N, 
		GOC	EndEntlp	Add length of entries between 
 		RSTK=C			  PrevN and N.
		C=0	A
		C=DAT0	1
		A=A+C	A
		A=A+C	A
		A=A+CON	A,6
		C=RSTK
		D0=D0+	1	
		GONC	N>Entlp

N>EntRlp		
		D0=D0-	1		Loop from PrevN downto N
 		RSTK=C			Add length of entries between
		C=0	A		  PrevN end N. (negative values)
		C=DAT0	1
		A=A-C	A
		A=A-C	A
		A=A-CON	A,6
		C=RSTK
		C=C+1	A
		GONC	N>EntRlp

EndEntlp
		C=A	A	Update R3[10-15] with offset for N
		AR3EX		  in RTAB
	 	GOSUB   ASLC5	
 		ASLC
		A=A+C	A
		C=A	A	
	 	GOSUB   ASRC5	
		ASRC	
	 	AR3EX
		CD0EX
		RTNCC


ASLC5	ASLC
	ASLC
	ASLC
	ASLC
	ASLC
	RTN

ASRC5	ASRC
	ASRC
	ASRC
	ASRC
	ASRC
	RTN


**********************************************************************
* In:	A[A]=ADDR R3=TABS
* Out:	A[A]=ADDR C[A]=FADDR
*	B[A]=N
**********************************************************************
ECentry?
		C=R3
		GOSBVL	=CSRW5
		D0=C
		D0=D0+	14
		C=A	A
		D=C	A
		C=DAT0	A
		B=C	A
		B=B-1	A
		A=0	A
		D0=D0+	5
		CD0EX
		RSTK=C
ECentrylp?
		C=A	A
		C=C+B	A
		CSRB.F	A
		CD0EX
		C=RSTK
		RSTK=C
		AD0EX
		C=C+A	A
		A=A+A	A
		A=A+A	A
		A=A+C	A
		AD0EX
		C=DAT0	A
		AD0EX
		A=R3.F	A
		A=A+C	A
		AD0EX
		C=DAT0	A
		?A=B	A
		GOYES	ECretent?
		?D<=C	A
		GOYES	ECentup
		A=A+B	A
		ASRB.F	A
		A=A+1	A
		GONC	ECentrylp?
ECentup		B=B+A	A
		BSRB.F	A
		GONC	ECentrylp?
ECretent?
		DCEX	A
		A=C	A
		C=RSTK
		C=D	A
		D0=D0+	5
		?C#A	A
		RTNYES
		RTN
**********************************************************************
EcModA		GOSUB	EcGetAnns
		?ABIT=1	6
		GOYES	+
		ABIT=1	6
		GONC	++
+		ABIT=0	6
		GOC	++

EcModLS		GOSUB	EcGetAnns
		?ABIT=1	4
		GOYES	+
		ABIT=1	4
		ABIT=0	5
		GONC	++
+		ABIT=0	4
		GOC	++

EcModRS		GOSUB	EcGetAnns
		?ABIT=1	5
		GOYES	+
		ABIT=1	5
		ABIT=0	4
		GONC	++
+

		ABIT=0	5
* Note: REPEAT IS ENABLED!
* This allows changing between
* f.ex  and +LS

++		DAT0=A	B
		ST=1	eDISPOK
		RTN

EcGetAnns	D0=(5)	=aANNUNCIATORS
		A=DAT0	A
		D0=A
		A=DAT0	B
		RTN
**********************************************************************
ECOFF		ST=0	eREPEAT
		GOLONG	EcDeepSleep
**********************************************************************
EcTogBeep	ST=0	eREPEAT
		ST=1	eDISPOK

		D0=(5)	=aSystemFlags
		C=DAT0	A
		C=C+CON	A,13
		D0=C
		C=DAT0	B
		?ST=0	sBPOFF
		GOYES	ecbeepon
		CBIT=0	3
		DAT0=C	B
		ST=0	sBPOFF
		RTN
ecbeepon	CBIT=1	3
		DAT0=C	B
		ST=1	sBPOFF
		RTN

**********************************************************************
EClexico
		ST=0	eREPEAT
		A=R4	
		GOSBVL	=ASRW5	
		?A#0	A		if no NTAB -> BadECKey
		GOYES	+
		GOLONG	BadECKey   
+		?ST=0	eLEXICO		if switching mode, must keep 
		GOYES	lexicoon	same current entry, so :	
		C=R2.F	A		Convert R2 :  Index for NTAB
		GOSUB	N>Entr		  to Index for DTAB
		CD0EX
		R0=C.F	A
		CD0EX
		A=DAT0	A		
		GOSUB	ECentry?
		C=B	A
		R2=C	A
		ST=0	eLEXICO
*		RTN
* adjust for possible synonyms; make sure we keep current selection
		GOSUB	N>Entr		A[A] = DTAB[N]; C[A] ->entry
		CD0EX
		AD0EX
		A=R0
		B=A	A		B[A] = ->entry in lexico mode
-		?C=B	A
		RTNYES
		D0=D0+	5
		C=R3	A
		A=DAT0	A
		C=C+A	A
*		?C>B	A		gone too far?
*		RTNYES
		A=R2			no, update N to next entry
		A=A+1	A
		R2=A.F	A
		GONC	-
		RTN			failsafe (N=0)

lexicoon
		C=R2.F	A
		GOSUB	N>Entr
		A=D0			Convert R2 : Index for DTAB 
	 	B=A	A		  to Index for NTAB
		A=R3
		LC(5)	#1E9+5	
		C=C+A	A
		A=0	A
		D=0	A
-		?C=B	A
		GOYES	+
		D0=C
		D0=D0+	5
		A=DAT0	1
		C=C+A	A
		C=C+A	A
		C=C+CON	A,6
		D=D+1	A
		GONC	-
		
+		C=D	A
		R2=C.F	A
		ST=1	eLEXICO
		RTN

**********************************************************************
EClMatch
		ST=0	eREPEAT
		?ST=1	eLMATCH
		GOYES	EcLmatchoff
	
		ST=1	eLMATCH
		GOSUB	EcSetIoAnn
		A=R1
		D0=A
		A=DAT0	S
		?A=0	S
		RTNYES
		GOLONG	EcUpdate

EcLmatchoff	ST=0	eLMATCH
*		GOTO	EcSetIoAnn

EcSetIoAnn	GOSUB	EcGetAnns
		D1=(5)	=ANNCTRL
		C=DAT1	B
		CBIT=0	5
		ABIT=0	1
		?ST=0	eLMATCH
		GOYES	+
		ABIT=1	1
		CBIT=1	5
+		DAT1=C	B
		DAT0=A	B
		RTN

**********************************************************************
EcClrCursor
		?ST=0	eCURSOR
		RTNYES
		GONC	EcTogCursor
EcSetCursor
		?ST=1	eCURSOR
		RTNYES

EcTogCursor
		?ST=1	eCURSOR
		GOYES	+
		ST=1	eCURSOR
		GONC	++
+		ST=0	eCURSOR
++
		C=R1.F	A
		D1=C
		A=0	A
		A=DAT1	1	X
		
		LC(5)	20+2*34+9*6*34+6
		A=A+C	A

		D1=(5)	=aADISP
		C=DAT1	A
		D1=C
		C=DAT1	A
		A=A+C	A
		D1=A
		
		P=	16-6
-		A=DAT1	B
		A=-A-1	B
		DAT1=A	1
		D1=D1+	16
		D1=D1+	16
		D1=D1+	2
		P=P+1
		GONC	-
		RTNCC
**********************************************************************
EcDelay?	ST=0	15
		A=R1
		D0=A
		D0=D0-	16
		A=DAT0	W			Old tim
		C=0	W
		LC(5)	8192*1/100
		?ST=0	eDELAY
		GOYES	+
		LC(5)	8192*4/10
+		A=A+C	W
		DAT0=A	W
-		GOSBVL	=AINRTN
		?A=0	X
		GOYES	+
		GOSBVL	=GetTimChk
		A=DAT0	W
		?C<A	W
		GOYES	-
		ST=0	eDELAY			Delay done
+		GOVLNG	=AllowIntr
**********************************************************************
* See ED WaitKey
**********************************************************************
EcWaitKey	?ST=0	eREPEAT
		GOYES	+
		GOSUB	EcDelay?
+		GOSUB	EcPopKey
		RTNNC

		GOSBVL	=DisableIntr
		GOSUB	EcRepKeys?
ecgosleep	GOSBVL	=settimeout
		GOSBVL	=AllowIntr

ecwaitnow	ST=0	13
		GOSUB	EcPopKey
		RTNNC

		GOSBVL	=DisableIntr
		GOSBVL	=clrbusy
		GOSBVL	=setannun
		GOSBVL	=AllowIntr

		D0=(5)	=TIMER1
		LC(1)	7
		DAT0=C	1
		D0=(2)	=TIMERCTRL.1
		LC(2)	#74
		DAT0=C	B

		D1=(5)	=CARDCTL
		LC(1)	8
		DAT1=C	1
		RSI
		?ST=1	13
		GOYES	ecwakeup
		SHUTDN
ecwakeup	LC(1)	#C
		DAT1=C	1
		C=DAT0	B
		?CBIT=0	3
		GOYES	+
		?ST=0	eBLINK
		GOYES	ecwaitnow
		GOSUBL	EcTogCursor
+		GOSBVL	=chk_timeout
		GONC	ecwaitnow
		GOSUB	EcDeepSleep
		ST=0	15
		GOTO	ecgosleep
**********************************************************************
* Initialize timers suitable for EC
**********************************************************************
EcInitClk	GOLONG	InitClk		Call ED subroutine
**********************************************************************
* Uses #80110 --> for saving data
**********************************************************************
EcDeepSleep	D1=(5)	(=IRAM@)-4	First save ST, RSTK and scratch
		C=DAT1	A
		D1=C
		D1=(4)	#110
		C=ST
		DAT1=C	X
		D1=D1+	3
		P=	16-4
-		C=RSTK
		DAT1=C	A
		D1=D1+	5
		P=P+1
		GONC	-
		C=R0
		DAT1=C	W
		D1=D1+	16
		C=R1
		DAT1=C	W
		D1=D1+	16
		C=R2
		DAT1=C	W
		D1=D1+	16
		C=R3
		DAT1=C	W
		D1=D1+	16
		C=R4
		DAT1=C	W
* Nighty night
		GOSUB	+
		CON(5)	=DOCOL
		CON(5)	=TurnOff
		CON(5)	=COLA
		CON(5)	=DOCODE
		REL(5)	->ECend
		GOTO	EcDeepCont
+		C=RSTK
		GOVLNG	=GETPTREVALC
* Restore registers and return
EcDeepCont	GOSBVL	=SAVPTR
		D1=(5)	(=IRAM@)-4
		C=DAT1	A
		D1=C
		D1=(4)	#110
		C=DAT1	X
		ST=C
		D1=(2)	#113+4*5
		P=	16-4
-		D1=D1-	5
		C=DAT1	A
		RSTK=C
		P=P+1
		GONC	-
		D1=(2)	#113+4*5
		C=DAT1	W
		R0=C
		D1=D1+	16
		C=DAT1	W
		R1=C
		D1=D1+	16
		C=DAT1	W
		R2=C
		D1=D1+	16
		C=DAT1	W
		R3=C
		D1=D1+	16
		C=DAT1	W
		R4=C
		RTN
**********************************************************************
* Uses #80100 --> for saving repetition keys
**********************************************************************
EcPopKey	GOSBVL	=chk_attn
		GONC	+
		C=0	A
		DAT1=C	A
		LC(2)	ATTNCODE
		GOC	++
+		GOSBVL	=POPKEY
		GOC	ecpoprepkey
++		RSTK=C
		ST=0	15
		GOSBVL	=clrtimeout
		GOSBVL	=GetTimChk
		A=R1
		D0=A
		D0=D0-	16
		DAT0=C	W
		GOSBVL	=showbusy
		GOSBVL	=AllowIntr
		ST=1	eDELAY
		D1=(5)	(=IRAM@)-4
		C=DAT1	A
		D1=C
		D1=(4)	#100
		C=0	A
		DAT1=C	1
		C=RSTK
		RTNCC

ecpoprepkey	D1=(5)	(=IRAM@)-4
		C=DAT1	A
		D1=C
		D1=(4)	#100
		?ST=1	eREPEAT
		GOYES	+
		C=0	A
		DAT1=C	1
		RTNSC
+		C=DAT1	P
		C=C-1	P
		RTNC
		DAT1=C	P
		P=C	0
		CD1EX
		C+P+1
		C+P+1
		CD1EX
		D1=D1-	1
		P=	0
		C=DAT1	B
		RSTK=C
		ST=0	15
		GOSBVL	=clrtimeout
		GOSBVL	=GetTimChk
		A=R1
		D0=A
		D0=D0-	16
		DAT0=C	W
		GOSBVL	=showbusy
		GOSBVL	=AllowIntr
		ST=0	eDELAY
		C=RSTK
		RTNCC
**********************************************************************
EcRepKeys?	?ST=0	eREPEAT
		RTNYES
		D1=(5)	(=IRAM@)-4
		C=DAT1	A
		D1=(5)	=aKEYSTATE
		C=DAT1	4
		D1=C
		A=DAT1	13
		C=0	W
		LCHEX	820801		Leave modifier and ON key
		A=A&C	W
		DAT1=A	13

		GOSBVL	=srvc_kbd	Gives max 3 modified keys

		D0=(5)	(=IRAM@)-4
		C=DAT0	A
		D0=C
		D0=(4)	#100
-		GOSBVL	=POPKEY
		RTNC			CS: No more keys found
		A=DAT0	P
		A=A+1	P		keys++
		DAT0=A	P
		D0=D0+	1
		A=DAT0	6
		DAT0=C	B
		D0=D0+	2
		DAT0=A	6
		D0=D0-	3
		GONC	-		BET

**********************************************************************
EcChrKey?	GOLONG	EdChrKey?
**********************************************************************

**********************************************************************
* Move key to B[B] from C[B]
* Get plane to B[XS]
* Remove shifts B[B]
* Reset LS&RS states
**********************************************************************
EcAdjustKey

* Changes to plane when
* modifier is held down:
*
*	Held
* Old	NS  LS  RS  A
*     +----------------
* NS  |	NS  LS  RS  ANS
* LS  |	        RS  ALS
* RS  |	    LS      ARS
* ANS |	    ALS ARS
* ALS |	        ARS
* ARS |	    ALS

		B=C	A
		A=0	A
		A=B	B
		LC(2)	#3F
		A=A&C	B

* Ignore adjust if only modifier down
		?A=0	B
		RTNYES
		ABEX	B	KeyCode
		ASR	B	[xxMMxxxx]

* [xx00xxxx] = NS, [xx10xxxx] = LS, [xx01xxxx] = A, [xx11xxxx] = RS

		D0=(5)	=aANNUNCIATORS
		C=DAT0	A
		D0=C
		C=DAT0	B	[xxxxLRAx]
		CBIT=0	7
		C=0	P
		A=A!C	B	[xxMMLRAx]
		ASRB.F	B
		ASRB.F	B	[MMLRAxxx], 0-3 = {NS LS A RS}
		
* Clear old LS & RS
		C=DAT0	B
		CBIT=0	4
		CBIT=0	5

* Clear old alpha if alpha key down
		?ABIT=0	1	Alpha mode?
		GOYES	+	No - skip
		?ABIT=1	0
		GOYES	+	No - skip
		CBIT=0	6

+		DAT0=C	B
		GOSUB	+
*			NLAR
		NIBHEX	1243	NS
		NIBHEX	2253	LS
		NIBHEX	3263	RS
		NIBHEX	0000	LRS!
		NIBHEX	4546	ANS
		NIBHEX	5556	ALS
		NIBHEX	6566	ARS
		NIBHEX	0000	ALRS!
*			NLAR
+
		C=RSTK
		A=A+C	A
		D0=A
		A=DAT0	XS
		B=A	XS
		RTN

**********************************************************************

->ECend
ENDCODE

* The names in the BIND are provided only for the convenience of DIS
* This prevents DIS from trying to get the tables from covered port again.

DEFINE @eccode	8GETLAM
DEFINE @ecrtab	7GETLAM
DEFINE @ecdtab	6GETLAM
DEFINE @ecfnt	5GETLAM
DEFINE @ecntab	4GETLAM
DEFINE @ecbuf	3GETLAM
DEFINE @ecstat	2GETLAM
DEFINE !ecstat	2PUTLAM
DEFINE @ecmod#	1GETLAM
DEFINE !ecmod#	1PUTLAM


  GetRplTab DUPNULL$? case SYNTAXERR
  GetDisTab DUPNULL$? case SYNTAXERR
  FNT1

  ' ECNTB @LAM ?SKIP		( Restore NTAB from lam, if not create it)
  :: ERRSET			( Create NTAB, if no memory push #0 )
	CODE
		GOSBVL	=SAVPTR         
	 	D1=D1+	5	
		A=DAT1	A
		D1=D1+	5
		GOSBVL	=ASLW5
		A=DAT1	A	
		R3=A
	
		GOSUBL	GetTot
		C=A	A
		C=C+1	A
		GOSBVL	=MAKE$N
		A=A-CON	A,5
		B=A	A
	
		A=R3
		LC(5)	#1E9+5
		A=A+C	A
		D1=A

		A=0	A
MKlenlp		B=B-1	A
		GOC	ENlenlp
		D1=D1+	5
		A=DAT1	1
		DAT0=A	1
		D0=D0+	1
		CD1EX
		C=C+A	A
		C=C+A	A
		C=C+1	A
		CD1EX
		GONC	MKlenlp
	
ENlenlp		GOVLNG	=GPPushR0Lp
	ENDCODE
	  ERRTRAP ZERO
  ; 

  NULLHXS 49 ( 16+33 ) EXPAND

  8ROLL				( Get Search String )
  CODE
	GOSBVL	=PopASavptr	Copy search string HXS (16->49)
	D0=A
	D0=D0+	5		D0= ->string + 5
	C=DAT0	A		
	C=C-CON	A,5
	CSRB.F	A		C=length of string
	A=C	A		
	A=A-CON	A,16
	GOC	+		Length OK
	C=0	A
	LC(1)	15		Cut to first 15 chars
+	A=DAT1	A		A= -> BUFHEX
	D1=A
	D1=D1+	16
	D1=D1+	10		D1= start of search str in BUF
	DAT1=C	1		store length 
	D1=D1+	1
	D0=D0+	5		d0 = ->STRING + 10 ( 1st char)
	B=C	A
-	B=B-1	A		Loop on n chars 
	GOC 	++		  -> END LOOP
	A=DAT0	B
	LC(2)	'a'		Convert to uppercase ...
	?A<C	B
	GOYES	+
	LC(2)	'z'
	?A>C	B
	GOYES	+
	ABIT=0	5		
+	DAT1=A	B		and store this char
	D0=D0+	2
	D1=D1+	2
	GONC	-
++	GOSBVL	=GETPTRLOOP
ENDCODE
  7ROLL		( Get default flags #STAT )

   ZERO

  ( COD     RTAB  DTAB  FONT    NTAB  $       #STAT   #N )
  { NULLLAM ECRPL ECDIS NULLLAM ECNTB NULLLAM NULLLAM NULLLAM } BIND

  BEGIN
	FLUSH

	@ecrtab @ecdtab @ecfnt @ecntab @ecbuf

	@ecstat @ecmod#

*	A bit more beautiful than straight RECLAIMDISP
	TOADISP UnScroll TURNMENUOFF CLEARVDISP
	@eccode EVAL
	FLUSH
	ITE
	::
	   !ecmod# !ecstat
	   ZERO #=casedrop		( Mode: View )
	   ::
	     DUP
	     CODE
		GOSBVL	=POP#
		AD0EX
		C=DAT0	A
		D0=A
		LA(5)	=DOGROB
		?A=C	A
		GOYES	+
		GOVLNG	=DOFALSE
+		GOSBVL	=POP#
		D1=D1-	5
		D=D-1	A
		DAT1=A	A
		GOVLNG	=DOTRUE
	     ENDCODE
	     ?SKIP :: #>HXS xDOB DROP ;
	     DUPTYPECSTR? ITE xED xVV DROPFALSE
	   ;
           DROPTRUE
        ;
        TRUE
  UNTIL
  ABND
 ;			( end of DoEd )

  FIFTYSIX 1GETABND ITE SetSysFlag ClrSysFlag	( Restore beep flag )

;
**********************************************************************

