**********************************************************************
*		JAZZ - Main SSTK Subroutines
**********************************************************************

DEFINE	rtab	LAM ~rtb		( RPL.TAB )
DEFINE	dtab	LAM ~dtb		( DIS.TAB )
DEFINE	exstk	LAM ~stk		( Exit flag )

DEFINE	@rtab	LAM ~rtb
DEFINE	@dtab	LAM ~dtb
DEFINE	@exstk	LAM ~stk
DEFINE	!exstk	' LAM ~stk STOLAM

DEFINE	hpdisflag THREE
DEFINE	hpdis?	THREE TestUserFlag

ASSEMBLE
=KeyObLam	EQU	#5A777
RPL

**********************************************************************
* Name:		xSSTK
* Interface:	( ? --> ? )
* Description:
*		SOL Replacement
**********************************************************************
ASSEMBLE
	CON(1)	8
RPL
xNAME SSTK
::
  CK0NOLASTWD

  CHECKME			( Error if covered )

  ( If SSTK already exists then exit it by setting exstk flag )
  ' exstk @LAM casedrop :: TRUE !exstk ;

  ( Setup SSTK variables )
  UNDO_TOP? IT ABND		( abandon possible saved stack )

  TEN GETLAMPAIR ITE_DROP
  ::
    UNROT2DROP
    EQ: KeyObLam
    NOT?SEMI
    1GETABND
    KeyOb!
    UNDO_TOP? IT ABND
    KeyOb@ ' KeyObLam
    ONE DOBIND
  ;


  GetRplTab GetDisTab FALSE	( Setup SSTK variables )
  { rtab dtab exstk } BIND
  CacheStack			( Save stack if necessary )

  NULLNAME SSTKLOOP		( Entry point to sstk )
  ::
  BEGIN
	AtUserStack		( Signal valid user stack )
	SysMenuCheck		( Do menu maintenance )
        NULLNAME SysDisplay!	( Do system display )
        ::
		DA2aOK?NOTIT ?DispStack!	( Display stack area )
		DA1OK?NOTIT ?DispStatus		( Display status area )
		DA2bOK?NOTIT DispEditLine	( Display edit area )
		DA3OK?NOTIT ?DispMenu		( Display menu area )
		ClrDAsOK			( Reset display flags )
	;
	GetKeyOb		( Wait for a key, return key object )
	ModSStkKey		( Modify to become SSTK key )
	ERRSET DoKeyOb		( Evaluate key object )
	ERRTRAP SysErrorTrap	( Clean up possible error )
	@exstk			( Exit condition )
  UNTIL
  ;


	  ( Abandon until sstk lams destroyed )
	  BEGIN
	    ' exstk @LAM DUP IT :: SWAPDROP ABND ;
	    NOT
	  UNTIL
*	* 1GETLAM stores KeyOb if started via EditLine!!!
*	* CacheStack			( Save stack if necessary )
*	  AtUserStack			( Validate user stack )


*  ( exit similarly to EQSTK or JAVA )
*  ( otherwise we might crash other SOLs )

*  UNDO_TOP? IT ABND		( abandon possible saved stack )
*  ABND				( abandon Jazz's LAMS )
  TEN GETLAMPAIR		( get 1st local env with name )
  casedrop CacheStack		( none found; save stack )
  UNROT2DROP			( otherwise check vs KeyObLam )
  EQ: KeyObLam
  NOTcase CacheStack
  1GETABND KeyOb!		( do as in ROM exiting editline )
  CacheStack
  KeyOb@ ' KeyObLam ONE DOBIND

;



**********************************************************************
* Modify keys for SSTK environment
**********************************************************************
NULLNAME ModSStkKey
::
  SX? ITE
  :: ' UArrow/View ;
  :: ' GX_UArrow/View ;
  EQcase
  :: NoEditLine? ?SKIP :: EDITPARTS #1=?SKIP RDROP ;
     DROP RESOROMP IStk
  ;
;
**********************************************************************
* ?DispStack replacement
**********************************************************************
NULLNAME ?DispStack!
::
  KEYINBUFFER? NOT		( No key in keybuffer.. )
  DA2aLess1OK?			( ..or quick update possible.. )
  ORcase
  NULLNAME DispStack!		( Then display stack )
  ::
	TOADISP			( Insure text display is used )
	DA2aLess1OK?		( Roll enough to validate display? )
	ClrNewEditL		( Clear DA2aLess1OK? flag )
	case			( Then maybe roll stack up )
	::
	  SetDA2aValid		( Signal stack display valid )
	  NoRollDA2?		( No roll requested? )
	  case ClrNoRollDA2	( Then just clear the roll flag )
	  ( Otherwise roll up display area 2 )
          CODE
		GOSBVL	=SAVPTR
		GOSBVL	=D0->Row1	->row1 in abuff
		LC(5)	2*8*34
		A=A+C	A
		D1=A
		LC(5)	1*10*34
		A=A+C	A
		D0=A
		LC(5)	3*10*34
		GOSBVL	=MOVEDOWN
		GOVLNG	=GETPTRLOOP
	  ENDCODE
	;
	ClrNoRollDA2		( No roll )
	ClrAbbrevStk		( Try normal stack display first )
	ERRSET DispStack1!	( Try to display stack )
	ERRTRAP
	( Handle errors in display )
	::
	  DropSysObs		( Drop any system objects from the stack )
	  ERROR@
	  #0=case DispStack!	( If attn then try again )
	  #NoRoomForSt JstGETTHEMSG DoWarning
	  SetAbbrevStk		( Signal abbreviate stack )
	  DispStack1!		( Display the stack )
	  ClrAbbrevStk		( Signal normal stack )
	;
	SetDA2aValid		( Signal stack display valid )
  ;
  SetDA2aBad			( Else force bad display area )
;

*NULLNAME DispStack1!
*::
*  LINESOFSTACK			( Number of lines in display area 2a )
*  DUP#0=csDROP			( None visible )
*  ONESWAP #1+			( One more in medium font )
*  ZERO_DO (DO)
*	ISTOP-INDEX		( Calculate display row number )
*	OVERDUP			( Get the stack level number )
*	#3+ ?PICK		( Get the stack level object )
*	DispLevel!
*	SWAP#1+SWAP		( Increment current stack level number )
*  +LOOP				( Adjust row number and loop )
*  DROP				( Drop stack level number )
*;


NULLNAME DispStack1!
::
  FIFTYSIX			( 7*8 rows of pixels )
  FOUR
  LINESOFSTACK #-
  TEN #* #-			( adjust by lines of stack )
  ONE				( #r #s : rows_of_pixesl stack_levels )

  BEGIN
	DUPDUP #3+ ?PICK	( #r #s #s ob T / #r #s #s F )

	NULLNAME StkObDecomp
	:: 
	  setStdWid
	  NOTcase #:>$

	  hpdis?		( use internal decompiler? )
	  case StkOb>$?Abbr
	  AbbrevStack?
	  NOTcase :: StkDis1 SWAP stackitw ;
          SWAP #:>$ SWAP GET_THE_TYPE
	;

	DUPLEN$ TWENTYTWO #>
	ITE
	  :: ONE TWENTYONE SUB$ CHR_... >T$ ;
	  ::
	    $ "                     "
	    !append$
	    ONE TWENTYTWO SUB$
	  ;
	$>GROB				( #r #s g )

	DUPGROBDIM			( #r #s g #h #w )
	5PICK 3PICK			( #r #s g #h #w #r #h )
	SIXTEEN #+ #< ITE		( #r #s g #h #w )
	::
	  5ROLL SIXTEEN #-		( #s g #h #w #r' )
	  3PICK SWAP#-			( #s g #h #w #r" )
	  UNROTSWAP			( #s g #r" #w #h )
	  ZERO 4UNROLL SUBGROB		( #s g #0 #r" #w #h )
	  ABUFF ZERO SIXTEEN GROB!	( #s g' a #0 #10 )
	  ZEROSWAP			( new max is zero; #0 #s )
	;
	::
	  DROP 4ROLL SWAP#-		( #s g #r' )
	  DUP4UNROLL			( #r' #s g #r' )
 	  ABUFF ZERO ROT GROB!		( #r' #s g a #0 #r' )
	;

	#1+ OVER#0=
  UNTIL
  2DROP
;

*( #DispRow #Level Obj TRUE --> #1 )
*( #DispRow #Level FALSE --> #1 )
*NULLNAME DispLevel!
*::
*  setStdWid			( Standard line width! )
*  hpdis? case
*  ( Normal HP48 decompiler )
*  ::
*    ITE StkOb>$?Abbr #:>$
*    SWAP #2+ DISPN ONE
*  ;
*  ITE
*    ::
*      AbbrevStack? NOTcase :: StkDis1 SWAP stackitw ;
*      SWAP #:>$ SWAP GET_THE_TYPE
*    ;
*    #:>$
*  SWAP #2+ DISPN ONE
*;


( #DispRow #Level Obj TRUE --> #1 )
( #DispRow #Level FALSE --> #1 )
NULLNAME DispLevel!
::
  StkObDecomp
  SWAP #2+ DISPN
;



**********************************************************************
* Name:		StkDis1
* Interface:	( ob --> $ )
* Description:
*	Disassembles object for single-line stack display
**********************************************************************
NULLNAME StkDis1
::
  @dtab @rtab		( --> ob dtab tab )

* An additional entry point for the benefit of Java v3.0

  NULLNAME JavaDis1
  ::
     MEM 1000 #< IT GARBAGE	( TOTEMPBOT? is too slow.. )
     3PICK SetStkDis1Ops	( --> ob dtab tab flag )
     NOTcase
     :: 3DROP "Invalid Object" TOTEMPOB ;
     NULL$TEMP			( --> ob dtab tab $labels )
     NULL$TEMP Diss		( --> ob dtab tab $labels $diss )
     5UNROLL 4DROP		( --> $diss )
  ;
;

**********************************************************************
